//+------------------------------------------------------------------+
//|                                                       MARSIH.mq5 |
//|                                                         Mr. Gold |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Mr. Gold"
#property link      "https://www.mql5.com"
#property version   "1.00"
//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|            |
//+----------------------------------------------+
input Smooth_Method MAMethod = MODE_LWMA;//  
input int RSI_Period = 14;              //  RSI
input int MA_Period = 5;                //  
input int Magic = 2;                    //    
input double Lot = 0.01;                // 
input bool BuyPosOpen=true;             //    
input bool SellPosOpen=true;            //    
input bool BuyPosClose=true;            //    
input bool SellPosClose=true;           //    
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input int MPhase = 15;                  //  
input ENUM_TIMEFRAMES InpInd_Timeframe=PERIOD_CURRENT; //  
input uint SignalBar=1;               //      

//----          
int TimeShiftSec;
//----      
int MR_00_Handle,MR_11_Handle,MR_22_Handle,MR_33_Handle;
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//                                                  | 
//+------------------------------------------------------------------+
#include <TradeAlgorithms.mqh>
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
   MR_00_Handle=iCustom(Symbol(),0,"Examples\\MARSI",RSI_Period,MA_Period,MPhase,MAMethod,0,0);
   if(MR_00_Handle==INVALID_HANDLE) Print("      marsicd");
   
   MR_11_Handle=iCustom(Symbol(),0,"Examples\\MARSI",RSI_Period,MA_Period,MPhase,MAMethod,1,0);
   if(MR_11_Handle==INVALID_HANDLE) Print("      marsicd");
   
   MR_22_Handle=iCustom(Symbol(),0,"Examples\\MARSI",RSI_Period,MA_Period,MPhase,MAMethod,2,0);
   if(MR_22_Handle==INVALID_HANDLE) Print("      marsicd");
   
   MR_33_Handle=iCustom(Symbol(),0,"Examples\\MARSI",RSI_Period,MA_Period,MPhase,MAMethod,3,0);
   if(MR_33_Handle==INVALID_HANDLE) Print("      marsicd");
   
//----          
   TimeShiftSec=PeriodSeconds(InpInd_Timeframe);

//----     
   min_rates_total=int(1+2+SignalBar);

   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   GlobalVariableDel_(Symbol());
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//----       
   if(BarsCalculated(MR_00_Handle)<min_rates_total||BarsCalculated(MR_11_Handle)<min_rates_total||BarsCalculated(MR_22_Handle)<min_rates_total||BarsCalculated(MR_33_Handle)<min_rates_total) return;

//----       IsNewBar()  SeriesInfoInteger()  
   LoadHistory(TimeCurrent()-PeriodSeconds(InpInd_Timeframe)-1,Symbol(),InpInd_Timeframe);

//----   
   double MR_00[2],MR_11[2],MR_22[2],MR_33[2];

//----   
   static bool Recount=true;
   static bool BUY_Open=false,BUY_Close=false;
   static bool SELL_Open=false,SELL_Close=false;
   static datetime UpSignalTime,DnSignalTime;

//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
   if(!SignalBar || NB.IsNewBar(Symbol(),InpInd_Timeframe) || Recount) //     
     {
      //----   
      BUY_Open=false;
      SELL_Open=false;
      BUY_Close=false;
      SELL_Close=false;
      Recount=false;

      //----      
      if(CopyBuffer(MR_00_Handle,0,SignalBar,2,MR_00)<=0) {Recount=true; return;}
      if(CopyBuffer(MR_11_Handle,0,SignalBar,2,MR_11)<=0) {Recount=true; return;}
      if(CopyBuffer(MR_22_Handle,0,SignalBar,2,MR_22)<=0) {Recount=true; return;}
      if(CopyBuffer(MR_33_Handle,0,SignalBar,2,MR_33)<=0) {Recount=true; return;}

      //----    
      if(MR_33[1]>55 && MR_11[1]>55)
        {
         if(BuyPosOpen && MR_33[1]<45 && MR_11[1]<45) BUY_Open=true;
         if(SellPosClose) SELL_Close=true;
         UpSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }

      //----    
      if(MR_22[1]>55 && MR_00[1]>55)
        {
         if(SellPosOpen && MR_22[1]<45 && MR_00[1]<45) SELL_Open=true;
         if(BuyPosClose) BUY_Close=true;
         DnSignalTime=datetime(SeriesInfoInteger(Symbol(),InpInd_Timeframe,SERIES_LASTBAR_DATE))+TimeShiftSec;
        }
     }
//+----------------------------------------------+
//|                              |
//+----------------------------------------------+
//----  
   BuyPositionClose(BUY_Close,Symbol(),Deviation_);

//----     
   SellPositionClose(SELL_Close,Symbol(),Deviation_);

//----  
   BuyPositionOpen(BUY_Open,Symbol(),UpSignalTime,0,0,Deviation_,0,0);

//----  
   SellPositionOpen(SELL_Open,Symbol(),DnSignalTime,0,0,Deviation_,0,0);
//----
  }
//+------------------------------------------------------------------+
